



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>HDU 2553   n皇后问题(回溯法)</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">HDU 2553   n皇后问题(回溯法)</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-25 04:05:55 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<div>&nbsp;DFS</div>
<p><strong>Time Limit:</strong>1000MS&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<strong>Memory Limit:</strong>32768KB&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<strong>64bit IO Format:</strong>%I64d &amp; %I64u</div>
<div>&nbsp;</div>
<div>
<div>
<p><strong>Description</strong></p>
<div>
<div>在N*N的方格棋盘放置了N个皇后，使得它们不相互攻击（即任意2个皇后不允许处在同一排，同一列，也不允许处在与棋盘边框成45角的斜线上。&nbsp;<br />你的任务是，对于给定的N，求出有多少种合法的放置方法。</p>
</div>
<div>&nbsp;</div>
</div>
</div>
<div>
<p><strong>Input</strong></p>
<div>
<div>共有若干行，每行一个正整数N&le;10，表示棋盘和皇后的数量；如果N=0，表示结束。</div>
<div>&nbsp;</div>
</div>
</div>
<div>
<p><strong>Output</strong></p>
<div>
<div>共有若干行，每行一个正整数，表示对应输入行的皇后的不同放置数量。</div>
<div>&nbsp;</div>
</div>
</div>
<div>
<p><strong>Sample Input</strong></p>
<div>
<div>
<div>1<br />
8<br />
5<br />
0 </div>
</div>
<div>&nbsp;</div>
</div>
</div>
<div>
<p><strong>Sample Output</strong></p>
<div>
<div>
<div>1<br />
92<br />
10</div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>题解：此题采用的是递归枚举法（回溯法）。本题采用逐行放置。要预先把合法的放置方法数保存起来</div>
<div>设皇后的编号依次为1，2，&hellip;&hellip;，n，则可以认为第i个皇后必须摆放在第i行，然后枚举第一个皇后的位置进行回溯，若某一次发现某个皇后无法找到摆放位置则直接返回，如果所有皇后都可以找到摆放位置，则说明存在一种摆法满足要求，统计有多少种摆法即可。</div>
<div>思路：每行最多只能有一个皇后，所以用a[ ]表示行向量，搜索从第一个行向量开始<br />按行向量递增搜索，一直到最后一个行向量结束时得到一种放置方法，用b[]保存摆法。</p>
</div>
<div>&nbsp;</div>
<div>AC代码：</div>
<div>
<div>
<pre class="prettyprint linenums">#include&lt;stdio.h&gt;<br />
#include&lt;cstring&gt;<br />
int vis[][];<br />
int c[];<br />
int cur,tot;<br />
int n;<br />
void search(int cur)<br />
{<br />
    if(cur==n)<br />
        tot++;<br />
    else for(int i=; i&lt;n; i++)<br />
        {<br />
            if(!vis[][i]&amp;&amp;!vis[][cur+i]&amp;&amp;!vis[][cur-i+n])<br />
            {<br />
                c[cur]=i;<br />
                vis[][i]=vis[][cur+i]=vis[][cur-i+n]=;<br />
                search(cur+);<br />
                vis[][i]=vis[][cur+i]=vis[][cur-i+n]=;<br />
            }<br />
        }<br />
}

int main()<br />
{<br />
    int b[];<br />
    for(n=; n&lt;=; n++)<br />
    {<br />
        memset(vis,,sizeof(vis));<br />
        tot=;<br />
        search();<br />
        b[n]=tot;<br />
    }<br />
    int bn;<br />
    while(scanf("%d",&amp;bn)&amp;&amp;bn)<br />
    {<br />
        printf("%d\n",b[bn]);<br />
    }<br />
    return ;<br />
}</pre>
</div>
</div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>AC代码：</div>
<div>
<div>
<pre class="prettyprint linenums"> #include&lt;iostream&gt;<br />
 #include&lt;cmath&gt;<br />
 using namespace std;<br />
 const int maxn=;<br />
 int b[maxn],a[maxn],sum,n;

 void dfs(int cur)<br />
 {<br />
     if(cur == n+)//递归边界，就有一种摆法<br />
         sum++;<br />
     else<br />
         for(int j = ; j &lt;=n; j++)<br />
         {<br />
             int ok=;<br />
             a[cur] = j;//尝试把第cur行的皇后放在第j列<br />
             for(int i = ; i&lt;cur; i++)   //检查是否和前面的皇后冲突<br />
                 if(a[i] == a[cur] || abs(i - cur) == abs(a[i] - a[cur]))<br />
                 {<br />
                     ok=;<br />
                     break;<br />
                 }<br />
             if(ok)<br />
                 dfs(cur+);//如果合法，继续递归<br />
         }<br />
 }

 int main()<br />
 {<br />
     for(int i = ; i &lt;=maxn; i++)<br />
     {<br />
         sum = ;<br />
         n= i;<br />
         dfs();<br />
         b[i] = sum;<br />
     }<br />
      while(cin&gt;&gt;n &amp;&amp; n)<br />
         cout&lt;&lt;b[n]&lt;&lt;endl;<br />
     return ;<br />
 }</pre>
</div>
</div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>一不小心找到了一个超简单，投机取巧的方法。。。。因为n&lt;=10。但是不能ac。</div>
<div>
<div>
<pre class="prettyprint linenums"> #include &lt;cstdio&gt;<br />
 main()<br />
 {<br />
     int n,a[]={,,,,,,,,,,,,};<br />
     while(scanf("%d",&amp;n))<br />
         printf("%d\n",a[n]);<br />
 }</pre>
</div>
</div>
<div>&nbsp;</div>
<div>&nbsp;</div>
</div>
<div>&nbsp;</div>
</div>
</div>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/8okdn4e9.html">ACK</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zyym29.html">presentViewController&colon; 如何不覆盖原先的 viewController界面</a>
		</li>
						<li><a href="https://www.batexi.com/a/qderrj79.html">MenuInflater用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e17ooe9.html">HttpHandler与HttpModule及实现文件下载</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xkd5e8.html">hdu 3357 水题</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gm7nrz9.html">python 的内置函数（1）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1rw2k8.html">CSS截取字符串</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdn2549.html">基于CAShapeLayer和贝塞尔曲线的圆形进度条动画【装载】</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jewew8.html">paho&period;mqtt&period;c打印日志</a>
		</li>
						<li><a href="https://www.batexi.com/a/9501gg08.html">后缀自动机模板&lpar;SPOJ1811&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7ozo5k8.html">centos7配置yum本地源（iso镜像）及局域网使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwr7mj9.html">Java 命令行启动时指定配置文件目录</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2vzx2q.html">Jetson tk1 刷机后要做的几件事</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwvmr79.html">【LeetCode每天一题】Reverse String</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gp1ywe9.html">&lbrack;翻译&rsqb;：Cinemachine 官方文档（0）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o44lkxq.html">Trie数 --- 统计公共前缀</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyv6kvmq.html">mysql用户创建及授权</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mjzj568.html">Linux下安装Zookeeper</a>
		</li>
						<li><a href="https://www.batexi.com/a/8koly16q.html">【Android】4&period;0  Android项目的基本结构</a>
		</li>
						<li><a href="https://www.batexi.com/a/93pmy0z8.html">20155215 2016-2017-2 《Java程序设计》第4周学习总结</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8k1gvy59.html">Nodejs in Visual Studio Code 09&period;企业网与CNPM</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rdrkgr8.html">424&period; Longest Repeating Character Replacement</a>
			</li>
						<li><a href="https://www.batexi.com/a/qydj0gjq.html">大数据分析神兽麒麟&lpar;Apache Kylin&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlm37l19.html">android设置view透明度的效果</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvvmpwyq.html">log4j 日志的初始化</a>
			</li>
						<li><a href="https://www.batexi.com/a/95xk10v8.html">android高效ORM数据库框架greenDao使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1z6xr69.html">iOS网络HTTP、TCP、UDP、Socket 知识总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j044wgq.html">Rational rose下载，安装，破解</a>
			</li>
						<li><a href="https://www.batexi.com/a/qde4yvz9.html">php创建读取 word&period;doc文档</a>
			</li>
						<li><a href="https://www.batexi.com/a/8z1n06x9.html">【转】UITextView 修改键盘 的return按钮</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
